﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CSScriptLibrary;

namespace LearnCSScript
{
    class Program
    {
        static void Main(string[] args)
        {
            CallFromInternal();
            CallFromScript();
        }

        static void CallFromScript()
        {
            Console.WriteLine("");
            Console.WriteLine("CallFromScript");
            DateTime beginTime = DateTime.Now;
            
            dynamic hello = CSScript.Evaluator.LoadFile("HelloWorld.cs");
            TimeSpan span = DateTime.Now - beginTime;
            Console.WriteLine("load and precompile script file, timespan= {0}", span);

            beginTime = DateTime.Now;
            hello.SayHello();

            span = DateTime.Now - beginTime;
            Console.WriteLine("call helloWorld timespan: {0}", span);
        }

        static void CallFromScriptLoadAndCall10Times()
        {
            Console.WriteLine("");
            Console.WriteLine("Call from script many times");
            DateTime beginTime = DateTime.Now;
            TimeSpan span;

            for (int i = 0; i < 10; ++i)
            {
                dynamic hello = CSScript.Evaluator.LoadFile("HelloWorld.cs");
                span = DateTime.Now - beginTime;
                Console.WriteLine("load and precompile script file, {0}, timespan= {1}", i, span);
                beginTime = DateTime.Now;
                hello.SayHello();
                span = DateTime.Now - beginTime;
                Console.WriteLine("time: {0}", span);    
            }            
        }

        static void CallFromScriptLoad1TimeAndCall10Times()
        {
            Console.WriteLine("");
            Console.WriteLine("CallFromScriptLoad1TimeAndCall10Times");
            DateTime beginTime = DateTime.Now;
            TimeSpan span;
            dynamic hello = CSScript.Evaluator.LoadFile("HelloWorld.cs");
            span = DateTime.Now - beginTime;
            Console.WriteLine("load and precompile script file, timespan= {0}", span);

            for (int i = 0; i < 10; ++i)
            {                
                beginTime = DateTime.Now;
                hello.SayHello();
                span = DateTime.Now - beginTime;
                Console.WriteLine("call helloWorld {0} time, timespan: {1}", i, span);
            }
        }

        static void CallFromInternal()
        {
            Console.WriteLine("");
            Console.WriteLine("CallFromInternal");
            DateTime beginTime = DateTime.Now;

            HelloWorld hello = new HelloWorld();
            hello.SayHello();

            TimeSpan span = DateTime.Now - beginTime;
            Console.WriteLine("call helloWorld timespan: {0}", span);
        }
    }
}
